`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2019/04/28 19:48:32
// Design Name: 
// Module Name: volume_ctl
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////

module volume_ctl( 
    rst_n, 
    clk, 
    volume_up,
    volume_down,
    curr_state
);
    input clk, rst_n, volume_down, volume_up;
    output reg [3:0] curr_state;

    reg [3:0] curr_state_next;
    
    always @*
    begin
        if (volume_up == 1'b1 && curr_state == 4'b1111)
            curr_state_next = 4'b1111;
        else if (volume_down == 1'b1 && curr_state == 4'd0)
            curr_state_next = 4'd0;
        else if (volume_up)
            curr_state_next = curr_state + 4'd1;
        else if (volume_down)
            curr_state_next = curr_state - 4'd1;
        else
            curr_state_next = curr_state;
    end

    always @(posedge clk or negedge rst_n)
        if (~rst_n)
            curr_state <= 4'd0;
        else
            curr_state <= curr_state_next;
endmodule




